--[[ABOUT: 
Script title: Armor Level
Script Author: Golden Sun (iLoveUS)
Script Version: 1
Script Next Update: NSS (Not so sure.)
Script Bugs Count: Thousands
Script Author Comments Counts: A little bit *whispers* many
]]

--[[CONFIG]]--
uniarmor = 0.3 --How much percent protects you when you got hitted by other weapons (default 0.3, MAX 1.0)

reducearmor = 2 --How much armor points will be reduced when it is in effect (default 2)
				--For example reducearmor is 2, and if armorpoints expected to be lost is 30 AP then
				--it will be divided to 2 and it will turn to 15 AP LOST.
				
killerarmornotice = 1 --Will the armor of the killer be revealed after getting killed?
					  --Enable - 1
					  --Disable -0
					  
helpadvertisement = 1 --Will the help adverstisement be show every minute?
					  --Enable - 1 
					  --Disable - 0
					  
wpnicons = 1 --Will the armor weapon icon be shown?
			 --Enable - 1
			 --Disable - 0
				
--Description
--[[This script is made by iLoveUS.
Armor Type is a lua script 
where you can choose an effective armor for a certain weapon.

For example: You knew that your enemy is equipped with a rifle, Let's say it's M4A1 
then you chose the Level III (which is assault & sniper weapon armor).
If you got damaged by his M4A1 then only your armor points will be reduced,
and more importantly, the AP points that will be reduced will be divide to 2 (which is in default)
Let's say the expected AP damage will be 20, it will divided to 2 so it's 10 AP 
and your hp will never get damaged until your armor points is down to 0 AP.

But in some cases, let's say...
You chosed Level III armor and your enemy equipped M4A1.
Then you got damaged by his M4A1 and he suddenly changed to USP (which is a light weapon)
and shot you. The effect will be, your hp will get damage and so your armor will be,
unlike the recent example, you will lose your health quickly and die.]]
				
--[[Weapon Class Table]]--

light = {1,2,3,4,5,6,20,21,22,23,24,74,50,85,69,78} --Light Weapons, mostly Handguns and SMGs (Glock,MP5,P90 etc.)

burst = {10,11,39,2} --Bursts Weapons, mostly Shotguns, like M3 (GLOCK AND FAMAS is also included)

rifles = {30,31,32,33,34,35,36,37,38,39} --Assault Weapons, like M4A1,AK47,FAMAS,GALIL ETC.

heavy = {40,90} --Heavy Weapons, most common in standard games, M249.

explosive = {51,73,76,86,47,48,49,77,87} --Explosive Weapons, most common on standard games, is HE grenade.
										--Grenade Launchers, RPG, Laser Mine ETC. are also included
										
function contains(table, element)
     for _, value in pairs(table) do
          if value == element then
          return true
          end
     end
return false
end

function initArray(m) --INITARRRRRRRRRRAY!							
	local array = {}								    
	for i = 1, m do
		array[i]=0
	end
	return array
end

lastarmor = initArray(32) --!@#^%@$!%$&^#% Not working
lasthitter = initArray(32) --For customkill function
lastweapon = initArray(32) --Last Weapons for customkill function
level = initArray(32) --Armor Level/Type
lightimg = initArray(32) --Light Weapon Armor Icon IMG
burstimg = initArray(32) --Burst Weapon Armor Icon IMG
rifleimg = initArray(32) --Rifle Weapon Armor Icon IMG
heavyimg = initArray(32) --Heavy Weapon Armor Icon IMG
exploimg = initArray(32) --Explosive  Weapon Armor Icon IMG

addhook("second","armorkevlar") --used for setting the "mp_kevlar" 
function armorkevlar()			--using config "uniarmor"
	for id = 1,32 do
		parse("mp_kevlar "..uniarmor.."")
	end
end

addhook("buy","buyol") --Check if the player has enough moneys to buy armor
function buyol(id,wpn) --Then proceed to the Armor choice menu
	if wpn == 57 then
		if player(id,"money") >= 650 then
			armormenu(id)
		end
	end
	if wpn == 58 then
		if player(id,"money") >= 1000 then
			armormenu(id)
		end
	end
end
		
function armormenu(id) --The Armor Choices Menu 
	menu(id,"Armor Level,Level I|Light Weapons,Level II|Burst Weapons,Level III|Assault Weapons,Level IV|Heavy Weapons,Level V|Explosive Weapons")
end


addhook("menu","armorpick") --Function for the menu
function armorpick(id,tit,lev) --Changes the armor level, armor icon.
if player(id,"armor") >= 65 then  --Check if the armor is bought too.
	if tit == "Armor Level" then
		if lev == 1 then
			imgremove(id)
			lightimg[id] = image("gfx/armor/light.png",0,0,132+id)
			imageblend(id,1)
			imagealpha(id,1)
			imagecolor(id,103,103,0)
			msg2(id,"000255000Level I 255255255Armor Equipped!")
			level[id]=1
		end
		if lev == 2 then
			imgremove(id)
			burstimg[id] = image("gfx/armor/burst.png",0,0,132+id)
			imageblend(id,1)
			imagealpha(id,1)
			imagecolor(id,103,103,0)
			msg2(id,"000255000Level II 255255255Armor Equipped!")
			level[id]=2
		end
		if lev == 3 then
			msg2(id,"000255000Level III 255255255Armor Equipped!")
			imgremove(id)
			rifleimg[id] = image("gfx/armor/assault.png",0,0,132+id)
			imageblend(id,1)
			imagealpha(id,1)
			imagecolor(id,103,103,0)
			level[id]=3
		end
		if lev == 4 then
			msg2(id,"000255000Level IV 255255255Armor Equipped!")
			imgremove(id)
			heavyimg[id] = image("gfx/armor/mg.png",0,0,132+id)
			imageblend(id,1)
			imagealpha(id,1)
			imagecolor(id,103,103,0)
			level[id]=4
		end
		if lev == 5 then
			msg2(id,"000255000Level V 255255255Armor Equipped!")
			imgremove(id)
			exploimg[id] = image("gfx/armor/explosive.png",0,0,132+id)
			imageblend(id,1)
			imagealpha(id,1)
			imagecolor(id,103,103,0)
			level[id]=5
		end
		end
	end
end

addhook("say","checkarmor") --"Armor" Help function
function checkarmor(id,say)  --Determine first the armor equipped and gives the information. 
	if say == "armor" then						 								
		if level[id] == 0 then													--Level of Armor		
			msg2(id,"255000000You have no armor equipped!") 					--Effectiveness of a certain weapon
			msg2(id,"255255255You will recieve more to all weapons! damages!") --The percent of protection to other weapons.
		end
		if level[id] == 1 then
			msg2(id,"255255255You have 000255000Level I Armor 255255255equipped!")
			msg2(id,"128128128Handguns, Submachine Guns and Melee 255255255damages will be significantly reduced.")
			msg2(id,"255255255Other weapons damages will be 000255000"..game("mp_kevlar").."% 255255255reduced.")
		end
		if level[id] == 2 then
			msg2(id,"255255255You have 000255000Level II Armor 255255255equipped!")
			msg2(id,"128128128Bursting Weapons like Shotguns255255255 damages will be significantly reduced.")
			msg2(id,"255255255Other weapons damages will be 000255000"..game("mp_kevlar").."% 255255255reduced.")
		end
		if level[id] == 3 then
			msg2(id,"255255255You have 000255000Level III Armor 255255255equipped!")
			msg2(id,"128128128Assault Rifles and Snipers 255255255damages will be significantly reduced.")
			msg2(id,"255255255Other weapons damages will be 000255000"..game("mp_kevlar").."% 255255255reduced.")
		end
		if level[id] == 4 then
			msg2(id,"255255255You have 000255000Level IV Armor 255255255equipped!")
			msg2(id,"128128128Heavy weapons 255255255like MG249 damages will be significantly reduced.")
			msg2(id,"255255255Other weapons damages will be 000255000"..game("mp_kevlar").."% 255255255reduced.")
		end
		if level[id] == 5 then
			msg2(id,"255255255You have 000255000Level V Armor 255255255equipped!")
			msg2(id,"128128128Explosives like RPG and Grenades 255255255damages will be significantly reduced.")
			msg2(id,"255255255Other weapons damages will be 000255000"..game("mp_kevlar").."% 255255255reduced.")
		end
		return 1
	end
end


addhook("always","DEATH") --Always set the armor level to 0 (no armor)
function DEATH()		--When the armor points (AP) is 0
	for id = 1,32 do
		if player(id,"exists") then
			if player(id,"armor") == 0 then
				level[id]=0
			end
		end
	end
end

addhook("hit","reducer")				--If the armor is effective on a weapon
function reducer(id,ids,wpn,hp,ap)      --Only Armor Points will be damaged
lasthitter[id]=ids 						--and AP Damage will be halfed
lastweapon[id]=wpn						--No HP damages until AP is down to 0(zero)
local reduced = ap/reducearmor
local damage = hp
	if level[id] == 1 then
		if contains(light,wpn) then
			parse("setarmor "..id.." "..(player(id,"armor")-reduced))
			return 1
		end
	end
	if level[id] == 2 then
		if contains(burst,wpn) then
			parse("setarmor "..id.." "..(player(id,"armor")-reduced))
			return 1 
		end
	end
	if level[id] == 3 then
		if contains(rifles,wpn) then
			parse("setarmor "..id.." "..(player(id,"armor")-reduced))
			return 1 
		end
	end
	if level[id] == 4 then
		if contains(heavy,wpn) then
			parse("setarmor "..id.." "..(player(id,"armor")-reduced))
			return 1 
		end
	end
	if level[id] == 5 then
		if contains(explosive,wpn) then
			parse("setarmor "..id.." "..(player(id,"armor")-reduced))
			return 1 
		end
	end
end

addhook("die","armorlost") --Turn the armor level to zero(no armor)
function armorlost(id)		 --When the player dies
	lastarmor[id]=level[id]  --and the last hitter
	level[id]=0 			--and also the last weapon used of the last hitter.
	lasthitter[id]=0
	lastweapon[id]=0
end

--For fair gameplay.
--Bots can buy kevlar and helm (Which is normal)
--Including the armor level  (Which is NOT normal)

addhook("spawn","bottybuys")
function bottybuys(id)
ra=math.random(1,5)
	if player(id,"bot") then
		if player(id,"money") >= 1000 then
			ai_buy(id,58)
			level[id]=ra
		end
		if player(id,"money") < 1000 then
			ai_buy(id,57)
			level[id]=ra
		end
	end
end

--After dying you will be notified of the armor who killed you.
--Configure it above.

addhook("die","deathnotice")
function deathnotice(id,ids)
if killerarmornotice == 1 then
	if level[ids] == 1 then
		msg2(id,"255000000"..player(ids,"name").."255255255 is equipped with a 000255000Level I Armor")
	end
	if level[ids] == 2 then
		msg2(id,"255000000"..player(ids,"name").."255255255 is equipped with a 000255000Level II Armor")
	end
	if level[ids] == 3 then
		msg2(id,"255000000"..player(ids,"name").."255255255 is equipped with a 000255000Level III Armor")
	end
	if level[ids] == 4 then
		msg2(id,"255000000"..player(ids,"name").."255255255 is equipped with a 000255000Level IV Armor")
	end
	if level[ids] == 5 then
		msg2(id,"255000000"..player(ids,"name").."255255255 is equipped with a 000255000Level V Armor")
	end
	if level[ids] == 0 then
		msg2(id,"255000000"..player(ids,"name").."255255255 has no armor equipped!")
	end
end
end


--DONT YOU EVER TOUCH MEEEEE!!!!
--function for removing junk images!
function imgremove(id)
	freeimage(burstimg[id])
	freeimage(lightimg[id])
	freeimage(rifleimg[id])
	freeimage(heavyimg[id])
	freeimage(exploimg[id])
end

--Function for helpadvertisement
--Displays help text every minute
--Configure it above.
addhook("minute","menutes")
function menutes()
	for id = 1,32 do
		if helpadvertisement == 1 then
			msg2(id,"255255255For info of your equipped armor, just type in chat 000000255armor")
		end
	end
end

addhook("always","removingimgs")
function removingimgs()	
	for id = 1,32 do
		if wpnicons == 0 then
			imgremove(id)
		end
	end
end

--END OF THE SCRIPT~~

--or maybe not...

--YES :D

--NO D:

--STFU

--FORGET ABOUT IT

--REALLY END OF THE SCRIPT~~

